#!/bin/sh
##
SRCS=" \
BasicDVIReader.cpp \
Bezier.cpp \
BgColorSpecialHandler.cpp \
Bitmap.cpp \
BoundingBox.cpp \
CLCommandLine.cpp \
CMap.cpp \
CMapManager.cpp \
CMapReader.cpp \
Calculator.cpp \
CharMapID.cpp \
Color.cpp \
ColorSpecialHandler.cpp \
DLLoader.cpp \
DVIReader.cpp \
DVIToSVG.cpp \
DVIToSVGActions.cpp \
Directory.cpp \
DvisvgmSpecialHandler.cpp \
EPSFile.cpp \
EllipticalArc.cpp \
EmSpecialHandler.cpp \
EncFile.cpp \
FileFinder.cpp \
FilePath.cpp \
FileSystem.cpp \
Font.cpp \
FontCache.cpp \
FontEncoding.cpp \
FontEngine.cpp \
FontManager.cpp \
FontMap.cpp \
FontMetrics.cpp \
FontWriter.cpp \
GFGlyphTracer.cpp \
GFReader.cpp \
GFTracer.cpp \
Ghostscript.cpp \
HashFunction.cpp \
HtmlSpecialHandler.cpp \
HyperlinkManager.cpp \
ImageToSVG.cpp \
InputBuffer.cpp \
InputReader.cpp \
JFM.cpp \
Length.cpp \
MapLine.cpp \
Matrix.cpp \
Message.cpp \
MetafontWrapper.cpp \
NoPsSpecialHandler.cpp \
OFM.cpp \
Opacity.cpp \
PDFHandler.cpp \
PDFParser.cpp \
PDFToSVG.cpp \
PSInterpreter.cpp \
PSPattern.cpp \
PSPreviewHandler.cpp \
PageRanges.cpp \
PageSize.cpp \
PapersizeSpecialHandler.cpp \
PathClipper.cpp \
PdfSpecialHandler.cpp \
PreScanDVIReader.cpp \
Process.cpp \
PsSpecialHandler.cpp \
PsSpecialHandlerProxy.cpp \
RangeMap.cpp \
SVGCharHandler.cpp \
SVGCharHandlerFactory.cpp \
SVGCharPathHandler.cpp \
SVGCharTspanTextHandler.cpp \
SVGElement.cpp \
SVGOutput.cpp \
SVGSingleCharTextHandler.cpp \
SVGTree.cpp \
ShadingPatch.cpp \
SignalHandler.cpp \
SourceInput.cpp \
SpecialManager.cpp \
StreamReader.cpp \
StreamWriter.cpp \
Subfont.cpp \
System.cpp \
TFM.cpp \
TensorProductPatch.cpp \
Terminal.cpp \
ToUnicodeMap.cpp \
TpicSpecialHandler.cpp \
TriangularPatch.cpp \
Unicode.cpp \
VFReader.cpp \
XMLDocument.cpp \
XMLNode.cpp \
XMLParser.cpp \
XMLString.cpp \
dvisvgm.cpp \
psdefs.cpp \
utility.cpp"

rm -f depend.mk
touch depend.mk
makedepend -fdepend.mk -o.obj -p./ --cpp=vc --cpp-bin=cl \
--newline=unix -DHAVE_CONFIG_H -DWIN32=1 -D__WIN32__=1 \
-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE \
-DNO_KPSE_DLL=1 -D_CRT_OBSOLETE_NO_DEPRECATE -D_SECURE_SCL=0 \
-DTEXLIVEWIN32=1 -DW32TEX=1 -I. -I.. -I../.. \
-I../../../libs/freetype/include \
-I../../../libs/zlib \
-I../libs/potrace -I../libs/clipper -I../libs/xxhash \
-I../libs/woff2/src -I../libs/brotli/enc \
-I../libs/woff2/include \
-I../libs/woff2/include/woff2 \
-I../libs/brotli/common \
-I../libs/boost \
-I../libs/brotli/include \
-I../libs/brotli/include/brotli \
-I../libs/variant/include \
-I../libs/variant/include/mpark \
-I./optimizer \
-I../libs/md5 $SRCS
